\documentclass[a4paper, hole]{./tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Tuto minidem}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien

\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newdemexo{02}{Collisions between grains}

\noindent The objective of this tutorial is to familiarize yourself with the
collision management of the minidem module. This tutorial demonstrates the use
of a function \texttt{manage\_contact()} which allows:
\begin{enumerate}
\item searching for grains in contact using the method \texttt{dem.lcm.compute\_colliding\_pair()}
\item generating contact forces using the function \texttt{dem.contact(gr1, gr2)}
\end{enumerate}
Please note that \texttt{manage\_contact()} is called by the function \texttt{time\_loop()}.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{02}{tuto-02\_exercice.py}. Run the script
  \dltutodem{02}{tuto-02\_exercice.py}.
\end{task}

\begin{info}
At this stage, you should obtain a simulation similar to the video \dltutodem{02}{tuto-02\_exercice.mp4}.
\end{info}

\begin{task}
  Does the collision between the grains seem realistic to you?
\end{task}

\begin{task}
  Open the script \texttt{minidem.py} and look for the function
  \texttt{contact(gr1, gr2, ....)}. Pay special attention to this portion of code:
  \vspace*{-1\baselineskip}
\begin{lstlisting}
def contact(gr1, gr2, stiffness=1e5, restitution_coef=0.5, exclude_bonded_grain = False):
  ...    
    if (delta > 0.):
        # compute normal force 
        normal     = rel_pos/dist
        force1     = normal * delta * stiffness
        gr1.force -= force1 # <- pay attention here
        gr2.force += force1 # <- and here too
\end{lstlisting}
  What do you notice about the management of contact forces? Is it absolute or incremental?
\end{task}

\begin{info}
  The forces acting on the grains are never "reset to zero". You will implement this functionality.
\end{info}

\begin{task}
  In the file \texttt{tuto-02\_exercice.py}, create a function
  \texttt{reset\_force()} that "resets to zero" the forces acting on the grains.
\end{task}

\begin{task}
  Call the function \texttt{reset\_force()} first in the time loop.
\end{task}

\begin{task}
  Change the number of iterations to \texttt{4000}.
\end{task}

\begin{info}
  At this stage, you should obtain a simulation similar to the video \dltutodem{02}{tuto-02\_correction.mp4}.
\end{info}

\end{document}
